aboutsummaryrefslogtreecommitdiff
path: root/git-stash.sh
diff options
context:
space:
mode:
authorDavid Caldwell <david@porkrind.org>2011-06-24 17:56:06 -0700
committerJunio C Hamano <gitster@pobox.com>2011-06-26 12:50:46 -0700
commit787513027a7d0af3c2cd2f04b85bc7136d580586 (patch)
treec16ac5b585cfff301d56d1eb6b67b823cf6a18c4 /git-stash.sh
parent99ac63b092f592b7181f94b6479f3a24dbfc8fdb (diff)
downloadgit-787513027a7d0af3c2cd2f04b85bc7136d580586.tar.gz
git-787513027a7d0af3c2cd2f04b85bc7136d580586.tar.xz
stash: Add --include-untracked option to stash and remove all untracked files
The --include-untracked option acts like the normal "git stash save" but also adds all untracked files in the working directory to the stash and then calls "git clean --force --quiet" to restore the working directory to a pristine state. This is useful for projects that need to run release scripts. With this option, the release scripts can be from the main working directory so one does not have to maintain a "clean" directory in parallel just for releasing. Basically the work-flow becomes: $ git tag release-1.0 $ git stash --include-untracked $ make release $ git clean -f $ git stash pop "git stash" alone is not enough in this case--it leaves untracked files lying around that might mess up a release process that expects everything to be very clean or might let a release succeed that should actually fail (due to a new source file being created that hasn't been committed yet). Signed-off-by: David Caldwell <david@porkrind.org> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 'git-stash.sh')
-rwxr-xr-xgit-stash.sh68
1 files changed, 64 insertions, 4 deletions
diff --git a/git-stash.sh b/git-stash.sh
index 0a9403653..7ffab6f26 100755
--- a/git-stash.sh
+++ b/git-stash.sh
@@ -7,7 +7,8 @@ USAGE="list [<options>]
or: $dashless drop [-q|--quiet] [<stash>]
or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
or: $dashless branch <branchname> [<stash>]
- or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
+ or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
+ [-u|--include-untracked] [-a|--all] [<message>]]
or: $dashless clear"
SUBDIRECTORY_OK=Yes
@@ -33,7 +34,14 @@ fi
no_changes () {
git diff-index --quiet --cached HEAD --ignore-submodules -- &&
- git diff-files --quiet --ignore-submodules
+ git diff-files --quiet --ignore-submodules &&
+ (test -z "$untracked" || test -z "$(untracked_files)")
+}
+
+untracked_files () {
+ excl_opt=--exclude-standard
+ test "$untracked" = "all" && excl_opt=
+ git ls-files -o -z $excl_opt
}
clear_stash () {
@@ -49,6 +57,7 @@ clear_stash () {
create_stash () {
stash_msg="$1"
+ untracked="$2"
git update-index -q --refresh
if no_changes
@@ -78,6 +87,25 @@ create_stash () {
git commit-tree $i_tree -p $b_commit) ||
die "Cannot save the current index state"
+ if test -n "$untracked"
+ then
+ # Untracked files are stored by themselves in a parentless commit, for
+ # ease of unpacking later.
+ u_commit=$(
+ untracked_files | (
+ export GIT_INDEX_FILE="$TMPindex"
+ rm -f "$TMPindex" &&
+ git update-index -z --add --remove --stdin &&
+ u_tree=$(git write-tree) &&
+ printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
+ rm -f "$TMPindex"
+ ) ) || die "Cannot save the untracked files"
+
+ untracked_commit_option="-p $u_commit";
+ else
+ untracked_commit_option=
+ fi
+
if test -z "$patch_mode"
then
@@ -122,13 +150,14 @@ create_stash () {
stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
fi
w_commit=$(printf '%s\n' "$stash_msg" |
- git commit-tree $w_tree -p $b_commit -p $i_commit) ||
+ git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
die "Cannot record working tree state"
}
save_stash () {
keep_index=
patch_mode=
+ untracked=
while test $# != 0
do
case "$1" in
@@ -146,6 +175,12 @@ save_stash () {
-q|--quiet)
GIT_QUIET=t
;;
+ -u|--include-untracked)
+ untracked=untracked
+ ;;
+ -a|--all)
+ untracked=all
+ ;;
--)
shift
break
@@ -162,6 +197,11 @@ save_stash () {
shift
done
+ if test -n "$patch_mode" && test -n "$untracked"
+ then
+ die "Can't use --patch and ---include-untracked or --all at the same time"
+ fi
+
stash_msg="$*"
git update-index -q --refresh
@@ -173,7 +213,7 @@ save_stash () {
test -f "$GIT_DIR/logs/$ref_stash" ||
clear_stash || die "Cannot initialize stash"
- create_stash "$stash_msg"
+ create_stash "$stash_msg" $untracked
# Make sure the reflog for stash is kept.
: >>"$GIT_DIR/logs/$ref_stash"
@@ -185,6 +225,11 @@ save_stash () {
if test -z "$patch_mode"
then
git reset --hard ${GIT_QUIET:+-q}
+ test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
+ if test -n "$untracked"
+ then
+ git clean --force --quiet $CLEAN_X_OPTION
+ fi
if test "$keep_index" = "t" && test -n $i_tree
then
@@ -234,9 +279,11 @@ show_stash () {
# w_commit is set to the commit containing the working tree
# b_commit is set to the base commit
# i_commit is set to the commit containing the index tree
+# u_commit is set to the commit containing the untracked files tree
# w_tree is set to the working tree
# b_tree is set to the base tree
# i_tree is set to the index tree
+# u_tree is set to the untracked files tree
#
# GIT_QUIET is set to t if -q is specified
# INDEX_OPTION is set to --index if --index is specified.
@@ -261,9 +308,11 @@ parse_flags_and_rev()
w_commit=
b_commit=
i_commit=
+ u_commit=
w_tree=
b_tree=
i_tree=
+ u_tree=
REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
@@ -311,6 +360,9 @@ parse_flags_and_rev()
IS_STASH_LIKE=t &&
test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
IS_STASH_REF=t
+
+ u_commit=$(git rev-parse --quiet --verify $REV^3 2>/dev/null) &&
+ u_tree=$(git rev-parse $REV^3: 2>/dev/null)
}
is_stash_like()
@@ -353,6 +405,14 @@ apply_stash () {
git reset
fi
+ if test -n "$u_tree"
+ then
+ GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
+ GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
+ rm -f "$TMPindex" ||
+ die 'Could not restore untracked files from stash'
+ fi
+
eval "
GITHEAD_$w_tree='Stashed changes' &&
GITHEAD_$c_tree='Updated upstream' &&